Index: README
===================================================================
--- README	(revision 9554)
+++ README	(revision 9555)
@@ -8,7 +8,7 @@
 Metacat: XML Metadata and Data Management System
 ------------------------------------------------                      
 
-Version: 2.5.0 Release
+Version: 2.6.0 Release
 
 Send feedback and bugs to: metacat-dev@ecoinformatics.org
                            http://bugzilla.ecoinformatics.org
@@ -54,6 +54,17 @@
 See the file "docs/install.html" for detailed instructions
 for your OS.
 
+Release Notes for 2.6.0:
+------------------------
+This release supports token-based authentication in the data registry
+as well as:
+* MetacatUI 1.11.0
+
+Release Notes for 2.5.1:
+------------------------
+This a minor release that improves:
+* Authentication token handling for the DataONE API
+
 Release Notes for 2.5.0:
 ------------------------
 This major release adds DataONE V2 API support
Index: build.properties
===================================================================
--- build.properties	(revision 9554)
+++ build.properties	(revision 9555)
@@ -80,4 +80,4 @@
 #  do NOT need to be configured
 #metacat.dir=/home/daigle/workspace/metacat
 
-maven.home=/usr/share/maven
\ No newline at end of file
+maven.home=/opt/local/share/java/maven2
\ No newline at end of file
Index: docs/user/metacat/source/conf.py
===================================================================
--- docs/user/metacat/source/conf.py	(revision 9554)
+++ docs/user/metacat/source/conf.py	(revision 9555)
@@ -45,9 +45,9 @@
 # built documents.
 #
 # The short X.Y version.
-version = '2.5'
+version = '2.6'
 # The full version, including alpha/beta/rc tags.
-release = '2.5.0'
+release = '2.6.0'
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
Index: docs/user/metacat/source/index.rst
===================================================================
--- docs/user/metacat/source/index.rst	(revision 9554)
+++ docs/user/metacat/source/index.rst	(revision 9555)
@@ -2,7 +2,7 @@
 Metacat Administrator's Guide
 =============================
 
-.. sidebar:: Version: 2.5.0
+.. sidebar:: Version: 2.6.0
 
     .. image:: themes/metacatui/static/metacat-logo-darkgray.png
        :height: 130pt
@@ -13,7 +13,7 @@
 
     License: GPL
     
-    Release Date: February, 2014
+    Release Date: March, 2016
 
 Metacat is a repository for data and metadata (documentation about data) that helps 
 scientists find, understand and effectively use data sets they manage or that 
@@ -26,11 +26,11 @@
 - Download Metacat
 
     - Binary Distribution (A war file installation)
-        - GZIP File: metacat-bin-2.5.0.tar.gz_
-        - ZIP File: metacat-bin-2.5.0.zip_
+        - GZIP File: metacat-bin-2.6.0.tar.gz_
+        - ZIP File: metacat-bin-2.6.0.zip_
     - Source Distribution (Full source, requiring build)
-        - GZIP File: metacat-src-2.5.0.tar.gz_
-        - ZIP File: metacat-src-2.5.0.zip_
+        - GZIP File: metacat-src-2.6.0.tar.gz_
+        - ZIP File: metacat-src-2.6.0.zip_
     - `Older versions`_
     
 - For Developers: Metacat `API documentation`_
@@ -39,13 +39,13 @@
 
 .. _API documentation: ./api/index.html
 
-.. _metacat-bin-2.5.0.tar.gz: http://knb.ecoinformatics.org/software/dist/metacat-bin-2.5.0.tar.gz
+.. _metacat-bin-2.6.0.tar.gz: http://knb.ecoinformatics.org/software/dist/metacat-bin-2.6.0.tar.gz
 
-.. _metacat-bin-2.5.0.zip: http://knb.ecoinformatics.org/software/dist/metacat-bin-2.5.0.zip
+.. _metacat-bin-2.6.0.zip: http://knb.ecoinformatics.org/software/dist/metacat-bin-2.6.0.zip
 
-.. _metacat-src-2.5.0.tar.gz: http://knb.ecoinformatics.org/software/dist/metacat-src-2.5.0.tar.gz
+.. _metacat-src-2.6.0.tar.gz: http://knb.ecoinformatics.org/software/dist/metacat-src-2.6.0.tar.gz
 
-.. _metacat-src-2.5.0.zip: http://knb.ecoinformatics.org/software/dist/metacat-src-2.5.0.zip
+.. _metacat-src-2.6.0.zip: http://knb.ecoinformatics.org/software/dist/metacat-src-2.6.0.zip
 
 .. _Older versions: http://knb.ecoinformatics.org/software/dist/
 
Index: docs/user/metacat/source/install.rst
===================================================================
--- docs/user/metacat/source/install.rst	(revision 9554)
+++ docs/user/metacat/source/install.rst	(revision 9555)
@@ -83,7 +83,7 @@
 Downloading the Metacat Installer is the simplest way to get started with the
 application. To download the installer: 
 
-1.  Browse to the `Metacat Download Page`_. In the Metacat section, select the link to the "GZIP file" (the link should look like: metacat-bin-X.X.X.tar.gz, where X.X.X is the latest version of Metacat e.g., 2.5.0) 
+1.  Browse to the `Metacat Download Page`_. In the Metacat section, select the link to the "GZIP file" (the link should look like: metacat-bin-X.X.X.tar.gz, where X.X.X is the latest version of Metacat e.g., 2.6.0) 
 2.  Save the file locally. 
 3.  Extract the Metacat package files by typing:
 
@@ -119,7 +119,7 @@
 ............................
 To get the Metacat source distribution:
 
-1. Browse to the `Metacat Download Page`_. In the Metacat section, select the link to the Metacat Source code (it will look something like this: metacat-src-X.X.X.tar.gz, where X.X.X is the latest version of Metacat, e.g., 2.5.0).
+1. Browse to the `Metacat Download Page`_. In the Metacat section, select the link to the Metacat Source code (it will look something like this: metacat-src-X.X.X.tar.gz, where X.X.X is the latest version of Metacat, e.g., 2.6.0).
 2. Save the file locally. 
 3. Extract the Metacat package files by typing (replace X.X.X with the current version number): 
 