Index: src/edu/ucsb/nceas/metacat/admin/AuthAdmin.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/AuthAdmin.java	(revision 9899)
+++ src/edu/ucsb/nceas/metacat/admin/AuthAdmin.java	(revision 9900)
@@ -190,6 +190,7 @@
 				// we need to write the options from memory to the properties
 				// file
 				PropertyService.persistProperties();
+				PropertyService.syncToSettings();
 
 				// Validate that the options provided are legitimate. Note that
 				// we've allowed them to persist their entries. As of this point
Index: src/edu/ucsb/nceas/metacat/admin/D1Admin.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/D1Admin.java	(revision 9899)
+++ src/edu/ucsb/nceas/metacat/admin/D1Admin.java	(revision 9900)
@@ -326,6 +326,7 @@
 					
 		            // persist them all
 					PropertyService.persistProperties();
+					PropertyService.syncToSettings();
 					
 					// save a backup in case the form has errors, we reload from these
 					PropertyService.persistMainBackupProperties();
Index: src/edu/ucsb/nceas/metacat/admin/EZIDAdmin.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/EZIDAdmin.java	(revision 9899)
+++ src/edu/ucsb/nceas/metacat/admin/EZIDAdmin.java	(revision 9900)
@@ -215,6 +215,7 @@
 					PropertyService.setPropertyNoPersist("guid.ezid.doishoulder.1", doishoulder);
 					// persist them all
 					PropertyService.persistProperties();
+					PropertyService.syncToSettings();
                     // save a backup in case the form has errors, we reload from these
                     PropertyService.persistMainBackupProperties();
 				}
Index: src/edu/ucsb/nceas/metacat/admin/GeoserverAdmin.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/GeoserverAdmin.java	(revision 9899)
+++ src/edu/ucsb/nceas/metacat/admin/GeoserverAdmin.java	(revision 9900)
@@ -201,6 +201,7 @@
 					PropertyService.setPropertyNoPersist("geoserver.context", context);
 					boolean reconfig = PropertyService.checkAndSetProperty(request, "geoserver.GEOSERVER_DATA_DIR");
 					PropertyService.persistProperties();
+					PropertyService.syncToSettings();
 					// put the web.xml in place
 					reconfig = true; //force all the time in cases where geoserver has been redeployed
 					if (reconfig) {
Index: src/edu/ucsb/nceas/metacat/admin/PropertiesAdmin.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/PropertiesAdmin.java	(revision 9899)
+++ src/edu/ucsb/nceas/metacat/admin/PropertiesAdmin.java	(revision 9900)
@@ -140,6 +140,7 @@
 						externalDir + FileUtil.getFS() + "solr-home");
 
 				PropertyService.persistProperties();
+				PropertyService.syncToSettings();
 
 				// Add the list of properties from metacat.properties to the request
 				Vector<String> propertyNames = PropertyService.getPropertyNames();
Index: src/edu/ucsb/nceas/metacat/properties/PropertyService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/properties/PropertyService.java	(revision 9899)
+++ src/edu/ucsb/nceas/metacat/properties/PropertyService.java	(revision 9900)
@@ -32,7 +32,9 @@
 import javax.servlet.ServletContext;
 import javax.servlet.http.HttpServletRequest;
 
+import org.apache.commons.configuration.ConfigurationException;
 import org.apache.log4j.Logger;
+import org.dataone.configuration.Settings;
 
 import edu.ucsb.nceas.metacat.shared.BaseService;
 import edu.ucsb.nceas.metacat.shared.ServiceException;
@@ -420,5 +422,19 @@
 	public static String getRecommendedExternalDir() {
 		return RECOMMENDED_EXTERNAL_DIR;
 	}
+	
+	/**
+	 * The properties on the Setting class isn't synchronized with the change the Metacat properties file. 
+	 * This method synchronizes (reloads) the properties' change to the Setting class when the property file was modified.
+	 */
+	public static void syncToSettings() throws GeneralPropertyException {
+	    try {
+	        Settings.getConfiguration();
+	        Settings.augmentConfiguration(CONFIG_FILE_PATH);
+	    } catch (ConfigurationException e) {
+	        e.printStackTrace();
+	        throw new GeneralPropertyException(e.getMessage());
+	    }
+	}
 
 }
\ No newline at end of file